/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.amap.lidar.amapvox.visualization.controllers;

import fr.amap.lidar.amapvox.visualization.opengl.entities.util.VoxelFilter;
import fr.amap.lidar.amapvox.visualization.views.VisualizationScene;

/**
 *
 * @author Tristan Muller (tristan.muller@cirad.fr)
 */
public class PropertiesController {
    
    private VisualizationScene scene;

    public PropertiesController() {
        this.scene = null;
    }
    
    public final void setScene(final VisualizationScene scene) {
        this.scene = scene;
    }

    public final VisualizationScene getScene() {
        return scene;
    }
    
    public final void changeCurrentProperty(final String property) {
        if (scene != null) {
            scene.getVoxelSpaceComponent().setProperty(property);
            scene.setSomethingsModified();
        }
    }
    
    public final void changeMinAndMax(final float min, final float max) {
        if (scene != null) {
            scene.getVoxelSpaceComponent().setColorMinAndMax(min, max);
            scene.setSomethingsModified();
        }
    }
    
    public final void changeFilter(final VoxelFilter filter) {
        if (scene != null) {
            scene.getVoxelSpaceComponent().setFilter(filter);
            scene.setSomethingsModified();
        }
    }
    
    public final void removeFilter(final int filter) {
        if (scene != null) {
            scene.getVoxelSpaceComponent().removeFilter(filter);
            scene.setSomethingsModified();
        }
    }
    
}
