/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.amap.lidar.amapvox.visualization.opengl.resources.programs;

import com.jogamp.opengl.GL3bc;
import fr.amap.lidar.amapvox.visualization.opengl.resources.materials.SkyboxMaterial;
import fr.amap.lidar.amapvox.visualization.opengl.resources.shaders.Shader;
import fr.amap.lidar.amapvox.visualization.opengl.resources.textures.TextureCubemap;

/**
 *
 * @author Tristan Muller (tristan.muller@cirad.fr)
 */
public class SkyboxProgram extends Program {
        
    TextureCubemap cubemap = null;
    
    public SkyboxProgram() {
        super("SkyboxProgram");
        setLayout("background");
        shader = new Shader("SkyboxShader");
        shader.setVertexSources(
                "/shaders/preprocessing/include/vertex.glsl",
                "/shaders/preprocessing/skybox/vertex.glsl");
        shader.setFragmentSources(
                "/shaders/preprocessing/include/fragment.glsl",
                "/shaders/preprocessing/skybox/fragment.glsl");
    }

    @Override
    protected void onLoad(GL3bc gl) {
        super.onLoad(gl);
    }

    @Override
    public void updateProperties() {
        super.updateProperties();
        
        /* Get materials values */        
        for (int i = 0; i < materials.size(); i++) {
            cubemap = ((SkyboxMaterial) 
                    materials.get(i)).getCubemap();
        }
    }

    @Override
    protected void onBind(GL3bc gl) {
        super.onBind(gl);

        /* Send textures */
        gl.glActiveTexture(GL3bc.GL_TEXTURE0);
        
        if (cubemap != null) {
            cubemap.bind(gl);
        } else {
            gl.glBindTexture(GL3bc.GL_TEXTURE_CUBE_MAP, 0);
        }
    }
    
}
