layout (location = 5) in vec4 color;

/* Out variables area */
out vec4 mainColor;

void main(void)
{
    mat4 model = getModelMatrix();

    mainColor = color;
    fragPosition = vec3(model * vec4(vertex, 1.0));
    fragNormal = mat3(transpose(inverse(model))) * normal;
    fragTexcoord = texcoord;
    
    /* Set the vertex position */
    gl_Position = proj * view * model * vec4(vertex * vec3(scale), 1.0);
}